config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users, controllers: { registrations: "registrations" }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

 unauthenticated do
  as :user do
    root :to => 'pages#home'
  end
 end
 
  authenticated do
      root :to => 'products#index'
  end

  root 'pages#home'
  get 'dashboard' => 'pages#dashboard'

  get 'contact' => 'pages#contact'

  get 'shopify/auth' => 'shopifys#auth'
  get 'shopify/install' => 'shopifys#install'


  resources :products
  resources :categories
  resources :charges

  get 'affiliate/home', to: 'affiliates#home'

  get 'unsubscribe', to: 'charges#endsubscription'

  get 'subscribe', to: 'charges#new'
  get 'profile', to: 'pages#profile'

  resources :users, except: [:new]
  resources :influencers 
  resources :audiences
  resources :faqs
  resources :engagements

  get 'pricing', to: 'pages#pricing'
  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'

  get 'admin', to: 'pages#admin'
end

app/models/category.rb
class Category < ApplicationRecord
    has_many :product_categories
    has_many :products, through: :product_categories

    has_many :influencer_categories
    has_many :influencers, through: :influencer_categories

    has_many :audience_categories
    has_many :audiences, through: :audience_categories
end

app/controllers/categories_controller.rb
class CategoriesController < ApplicationController

    before_action :authenticate_user!
    before_action :is_user_subscribed

    def new
        if current_user.admin?
            @category = Category.new
        else
            redirect_to root_path
        end

    end

    def create 
        if  current_user.admin?
            @category = Category.new(category_params)
            if @category.save
                redirect_to categories_path
            else
                render 'new'
            end
        else
            redirect_to root_path
        end
    end

    def update
        if  current_user.admin?
            set_category
            if @category.update(category_params)
                redirect_to category_path(@category)
            else
                render 'edit' 
            end
        else
            redirect_to root_path
        end
    end

    def edit
        if  current_user.admin?
          set_category
        else
            redirect_to root_path
        end
    end

    def show 
            set_category
            @title = @category.name + " Products"
            @categories = Category.all.order('name ASC')
            @products = @category.products.paginate(page: params[:page], per_page: 16).order('id DESC')
    end

    def destroy
        set_category
        @category.delete

        redirect_to categories_path
    end

    def index 
        if current_user.admin?
            @categories = Category.all
        else
            redirect_to root_path
        end
    end

    private
        def category_params
            params.require(:category).permit(:name)
        end

        def set_category
            @category = Category.find(params[:id])
        end

        def is_user_subscribed
            if !current_user.subscribed? and !current_user.admin?
                redirect_to subscribe_path
            end
        end
    
end

app/views/categories/_form.html.erb
<%= form_for(@category, html:{class: "form-horizontal", role: "form"}) do |f| %>
                    <div class="form-group">
                    <div class="control-label col-sm-2">  
                            <%= f.label :name %> 
                    </div>
                    <div class="col-sm-8">
                            <%= f.text_field :name, class: "form-control", placeholder: "Name of category", autofocus: true %>
                        </div>
                    </div>
                    <div class="form-group">
                        <div class="col-sm-offset-2 col-sm-10">
                            <%= f.submit class: 'btn btn-primary btn-lg' %>
                        </div>
                    </div>
            <% end %>

app/views/categories/edit.html.erb
<div class="container">
   <div class="row">
        <div class="col-md-12 col-md-offset-2">
            <h1>Edit Category</h1>
        </div>
        <div class="col-md-12">
            <%= render "form" %>
            <div class="col-sm-offset-2 col-sm-10">
                <%= link_to "Delete this category", category_path(@category), method: :delete %>
            </div>
        </div>
    </div>
</div>

app/views/categories/index.html.erb
<div align="center" class="container">
    <section class="product-navigation header top-margin">
        <h1 class="animated">Categories</h1>
    </section>
    <hr>
  <% @categories.each do |category| %>
    <div class="row">
      <div class="col-md-8 col-xs-12 col-md-offset-2">
        <div class="category-card hvr-grow">
            <div class="col-md-4 col-xs-12">
                <h1> <%= category.name %> </h1>
            </div>
            <div class="col-md-3 col-xs-12">
              <h1><%= category.products.count %> Products</h1>
            </div>
            <div class="col-md-3 col-xs-12">
              <%= link_to(category_path(category)) do %><button class="btn btn-primary btn-lg">View Products</button><% end %>
            </div>
            <div class="col-md-2 col-xs-12">
              <% if current_user.admin? %>
                  <%= link_to(edit_category_path(category)) do %><button style="position: relative;" class="btn btn-primary btn-lg">Edit</button><% end %>
              <% end %>
            </div>
        </div>
      </div>
    </div>
  <% end %>
</div>

app/views/categories/new.html.erb
<div class="container">
   <div class="row">
        <div class="col-md-12 col-md-offset-2">
            <h1>New Category</h1>
        </div>
        <div class="col-md-12">
            <%= render "form" %>
        </div>
    </div>
</div>

app/views/categories/show.html.erb
    <%= render "shared/productview" %>